package sedplugin.errors;

/**
 * @author	Gr&eacute;gory Mantelet (CDS)
 * @version 03/2011
 */
public class SEDException extends Exception {
	
	private static final long serialVersionUID = 1L;
	
	/** Title of this exception. By default, an empty string. */
	protected String title = "";
	
	/** Explanation about the source of this exception. By default, an empty string. */
	protected String origin = "";
	
/* ************ */
/* CONSTRUCTORS */
/* ************ */
	public SEDException(String errorTitle, String errorOrigin, String errorDescription){
		super(errorDescription);
		title = errorTitle;
		origin = errorOrigin;
	}
	
	public SEDException(Throwable ex, String errorOrigin){
		super(ex);
		title = ex.getClass().getName();
		origin = errorOrigin;
	}
	
/* ***************** */
/* GETTERS & SETTERS */
/* ***************** */
	/**
	 * Gets the title of this SEDException.
	 * @return	Its title.
	 */
	public final String getTitle(){
		return title;
	}
	
	/**
	 * Gets the source/cause of this SEDException.
	 * @return	Its source/cause.
	 */
	public final String getOrigin(){
		return origin;
	}
	
	public String toHTMLString(){
		String txt = "<p align=\"center\">"+title+"</b></p><ul><li><u>Origin:</u> "+origin+"</li>";
		
		txt += "<li><u>Message:</u> "+getMessage()+((getCause() != null)?"\n=>"+getCause().getMessage():"")+"</li></ul>";
		
		return txt;
	}
	
	public String toString(){
		if (getCause() != null)
			return "## SEDException["+getCause().getClass().getName()+"] ##\n\t- Title: "+title+"\n\t- Origin: "+origin+"\n\t- Message: "+getCause();
		else
			return "## SEDException ##\n\t- Title: "+title+"\n\t- Origin: "+origin+"\n\t- Message: "+getMessage();
	}
}
