package sedplugin.errors.unit;

import sedplugin.errors.SEDException;

public class UnknownUnitException extends SEDException {

	private static final long serialVersionUID = 1L;

	protected String unit = null;
	
	protected int indUnit = -1;
	
	public UnknownUnitException(String unknownUnit, String errorOrigin) {
		super("Unknown unit", errorOrigin, "The unit \""+unknownUnit+"\" is unknown !");
		unit = unknownUnit;
	}
	
	public UnknownUnitException(int indUnit, String errorOrigin){
		super("Incorrect unit", errorOrigin, (indUnit==-1)?"No specified unit !":"There is no "+indUnit+"-th unit !");
		this.indUnit = indUnit;
	}
	
	public String getUnknownUnit(){
		return unit;
	}
	
	public int getUnitIndex(){
		return indUnit;
	}

}
