package sedplugin.sed.source.operation;

public abstract class OperationToken {

	public static enum TokenType {
		CONSTANT, SED, FUNCTION;
	}

	/** Original string expression of the token. */
	public final String expression;

	/** The position of the first character of this token in the whole string expression. */
	public final int beginPosition;

	/** The position of the last character of this token in the whole string expression. */
	public final int endPosition;

	public final TokenType type;

	public OperationToken(final String expr, final TokenType t, final int begin, final int end){
		expression = expr;
		type = t;
		beginPosition = begin;
		endPosition = end;
	}

	@Override
	public final String toString(){
		return expression;
	}

	public abstract int getNbPoints();

}
